use strict;
no warnings qw(redefine);

sub Apply {
    my $self = shift;
    my %args = ( TicketObj      => undef,
                 TransactionObj => undef,
                 @_ );

    # We want to make sure that if a scrip dies, we don't get
    # hurt
    eval {

        #Load the scrip's Condition object
        $self->ConditionObj->LoadCondition(
                                      ScripObj       => $self,
                                      TicketObj      => $args{'TicketObj'},
                                      TransactionObj => $args{'TransactionObj'},
        );

#!!pape: deactivate_scrip.patch {{
        require RT::QueueDeactivatedScrip;
        my $info = new RT::QueueDeactivatedScrip( $self->CurrentUser );
        my $ticket = $args{'TicketObj'};
	if ( $ticket && $ticket->QueueObj &&
	     $info->ScripIsDeactivatedForQueue( $ticket->QueueObj->Id, $self->Id ) ) {
	    $RT::Logger->info( "Scrip ".$self->Id." has not been applied, since it is deactivated for Queue ".$ticket->QueueObj->Name );
	    $self->ConditionObj->DESTROY;
	    return (undef);
	}
#!!pape: deactivate_scrip.patch }}

        unless ( $self->IsApplicable() ) {
            $self->ConditionObj->DESTROY;
            return (undef);
        }

        #If it's applicable, prepare and commit it
        $self->ActionObj->LoadAction( ScripObj       => $self,
                                      TicketObj      => $args{'TicketObj'},
                                      TransactionObj => $args{'TransactionObj'},
        );

        unless ( $self->Prepare() ) {
            $RT::Logger->info(
                          "$self: Couldn't prepare " . $self->ActionObj->Name );
            $self->ActionObj->DESTROY();
            $self->ConditionObj->DESTROY();
            return (undef);
        }
        unless ( $self->Commit() ) {
            $RT::Logger->info(
                           "$self: Couldn't commit " . $self->ActionObj->Name );
            $self->ActionObj->DESTROY();
            $self->ConditionObj->DESTROY();
            return (undef);
        }

        #Searchbuilder caching isn't perfectly coherent. got to reload the ticket object, since it
        # may have changed
        $args{'TicketObj'}->Load($args{'TicketObj'}->Id);

        #We're done with it. lets clean up.
        #TODO: something else isn't letting these get garbage collected. check em out.
        $self->ActionObj->DESTROY();
        $self->ConditionObj->DESTROY();
        return (1);
    };
    if ($@) {
        $RT::Logger->error( "Scrip " . $self->Id . " died. - " . $@ );
    }

}

1;
